﻿WAComponent subclass: #WACardapio
	instanceVariableNames: 'cardapio minPreco maxPreco'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood-IfaceGarcom'!
!WACardapio commentStamp: '<historical>' prior: 0!
Eu sou a pagina do cardapio.!


!WACardapio methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 22:17'!
renderContentOn: html
	html text: 'Listar pratos entre'.
	html form: [
		html text: 'R$'.
		html textInput id: 'minfilter';
			value: minPreco;
			callback: [:value | minPreco := value].
	].
	html text: 'e'.
	html form: [
		html text: 'R$'.
		html textInput id: 'maxfilter';
			value: maxPreco;
			callback: [:value | maxPreco := value].
	].
	html break.
	html table: [
		html tableRow: [
			html tableData: 'Prato'.
			html tableData: 'Preco'.
		].
		cardapio pratosDoCardapio do: [
			:x |
				((x preco >= minPreco) and: [x preco <= maxPreco])
				ifTrue: [
					html tableRow: [
						html tableData with: [
							html text: x nome.
							html break.
							html text: '(', x listaIngredientes, ')'.
						].
						html tableData: 'R$ ', x preco asString, ',00'.
					].
				].
			].
	].
	html anchor callback: [self answer];
		with: '<< Voltar'.! !

!WACardapio methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 02:23'!
updateRoot: html
	super updateRoot: html.
	html title: 'Cardapio'.! !


!WACardapio methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 01:13'!
cardapio: umCardapio
	cardapio := umCardapio.! !

!WACardapio methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 21:43'!
maxPreco: preco
	maxPreco := preco.! !

!WACardapio methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 21:43'!
minPreco: preco
	minPreco := preco.! !


!WACardapio methodsFor: 'initialization' stamp: 'JFAE 6/12/2007 21:35'!
inicializa
	minPreco := 0.
	maxPreco := 10000.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

WACardapio class
	instanceVariableNames: ''!

!WACardapio class methodsFor: 'initialization' stamp: 'JFAE 6/12/2007 21:35'!
cardapio: umCardapio
	| pagina |
	pagina := WACardapio new.
	pagina cardapio: umCardapio.
	pagina inicializa.
	^pagina.! !


WAComponent subclass: #WACardapioPedido
	instanceVariableNames: 'cardapio pedido minPreco maxPreco'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood-IfaceGarcom'!
!WACardapioPedido commentStamp: 'JFAE 6/12/2007 02:31' prior: 0!
Eu sou a classe que representa a pagina de cardapio apos a inicializacao de um pedido. Novos pratos podem ser adicionados atraves de mim.!


!WACardapioPedido methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 22:16'!
renderContentOn: html
	html text: 'Listar pratos entre'.
	html form: [
		html text: 'R$'.
		html textInput id: 'minfilter';
			value: minPreco;
			callback: [:value | minPreco := value].
	].
	html text: 'e'.
	html form: [
		html text: 'R$'.
		html textInput id: 'maxfilter';
			value: maxPreco;
			callback: [:value | maxPreco := value].
	].
	html break.
	html table: [
		html tableRow: [
			html tableData: 'Prato'.
			html tableData: 'Preco'.
			html tableData: ''.
		].
		cardapio pratosDoCardapio do: [
			:x |
				((x preco >= minPreco) and: [x preco <= maxPreco])
					ifTrue: [
					html tableRow: [
						html tableData with: [
							html text: x nome.
							html break.
							html text: '(', x listaIngredientes, ')'.
						].
						html tableData: 'R$ ', x preco asString, ',00'.
						html tableData with: [
							html anchor id: 'add', x id asString;
								callback: [self adiciona: x];
								with: 'Adicionar'.
							].
					].
				].
			].
	].
	html anchor id: 'voltar';
		callback: [self answer];
		with: '<< Voltar'.! !

!WACardapioPedido methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 02:37'!
updateRoot: html
	super updateRoot: html.
	html title: 'Cardapio'.! !


!WACardapioPedido methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 14:12'!
adiciona: umPrato
	pedido adicionaPrato: umPrato.! !

!WACardapioPedido methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 02:36'!
cardapio: umCardapio
	cardapio := umCardapio.! !

!WACardapioPedido methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 02:42'!
pedido: umPedido
	pedido := umPedido.! !


!WACardapioPedido methodsFor: 'initialization' stamp: 'JFAE 6/12/2007 22:15'!
inicializa
	minPreco := 0.
	maxPreco := 10000.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

WACardapioPedido class
	instanceVariableNames: ''!

!WACardapioPedido class methodsFor: 'initialization' stamp: 'JFAE 6/12/2007 22:16'!
cardapio: umCardapio pedido: umPedido
	| pagina |
	pagina := WACardapioPedido new.
	pagina cardapio: umCardapio.
	pagina pedido: umPedido.
	pagina inicializa.
	^pagina.! !


WAComponent subclass: #WAFecharPedido
	instanceVariableNames: 'pedido pago troco foiPago mensErro'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood-IfaceGarcom'!

!WAFecharPedido methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 22:29'!
renderContentOn: html
	html form: [
		html table: [
			html tableRow: [
				html tableData: 'Total: '.
				html tableData: 'R$ ', pedido calculaPreco asString, ',00'.
			].
			html tableRow: [
				html tableData: 'Valor pago: '.
				foiPago
				ifFalse: [
					html tableData with: [
						html textInput id: 'valorPago';
							callback: [:value | self pago: value];
							value: pago.
						html text: '*'.
					].
				]
				ifTrue: [
					html tableData: 'R$ ', pago asString, ',00'.
				].
			].
			html tableRow: [
				html tableData: 'Troco: '.
				html tableData: 'R$ ', troco asString, ',00'.
			].
		].
		foiPago
		ifFalse: [
			html text: mensErro.
			html break.
			html anchor callback: [self answer];
				with: '<< Voltar'.
			html break.
			html anchor id: 'pagaPedido';
				callback: [self realizarPagamento];
				with: 'Efetuar Pagamento >>'.
			html break.
			html break.
			html text: '* Digite o valor e pressione enter.'.
		]
		ifTrue: [
			html anchor callback: [self sairSistema];
				with: 'Encerrar Sessao >>'.
		].
	].! !

!WAFecharPedido methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 04:39'!
updateRoot: html
	super updateRoot: html.
	html title: 'Fechar Pedido'.! !


!WAFecharPedido methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 04:58'!
foiPago: valor
	foiPago := valor.! !

!WAFecharPedido methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 05:10'!
mensErro: mensagem
	mensErro := mensagem.! !

!WAFecharPedido methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 21:25'!
pago: valorPago
	pago := valorPago.! !

!WAFecharPedido methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 04:38'!
pedido: umPedido
	pedido := umPedido.! !

!WAFecharPedido methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 21:22'!
realizarPagamento
	(pago - pedido calculaPreco) < 0
	ifFalse: [
		troco := pago - pedido calculaPreco.
		foiPago := true.
	]
	ifTrue: [
		mensErro := 'Valor pago insuficiente!!'.
	].
	Transcript show: (pago - pedido calculaPreco).! !

!WAFecharPedido methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 22:19'!
sairSistema
	self call: (WAInicioGarcom new).! !

!WAFecharPedido methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 04:57'!
troco: valorTroco
	troco := valorTroco.! !


!WAFecharPedido methodsFor: 'initialization' stamp: 'JFAE 6/12/2007 21:18'!
inicializa
	pago := 0.
	troco := 0.
	foiPago := false.
	mensErro := ''.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

WAFecharPedido class
	instanceVariableNames: ''!

!WAFecharPedido class methodsFor: 'initialization' stamp: 'JFAE 6/12/2007 21:18'!
pedido: umPedido
	| pagina |
	pagina := WAFecharPedido new.
	pagina pedido: umPedido.
	pagina inicializa.
	^pagina.! !


WATask subclass: #WAGerenciador
	instanceVariableNames: 'cardapio pedido'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood-IfaceGarcom'!
!WAGerenciador commentStamp: '<historical>' prior: 0!
Eu sou a classe que gerencia o controle de fluxo da interface web.!


!WAGerenciador methodsFor: 'as yet unclassified' stamp: 'JFAE 6/12/2007 18:33'!
displayStartingPage
	self call: (WAInicioGarcom new cardapio: cardapio)! !


WAComponent subclass: #WAInicioGarcom
	instanceVariableNames: 'cardapio robo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood-IfaceGarcom'!
!WAInicioGarcom commentStamp: '<historical>' prior: 0!
Eu sou a pagina inicial da interface do garcom.!
]style[(47)f1!


!WAInicioGarcom methodsFor: 'initialization' stamp: 'JFAE 6/12/2007 22:44'!
initialize
	super initialize.
	self registerForBacktracking.
	cardapio := Cardapio unico.
	robo := Robo novoComEstilo: 'fast-food'.! !


!WAInicioGarcom methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 22:31'!
renderContentOn: html
	html heading: 'Interface do garçom'.
	html break.
	html anchor id: 'cardapio';
		callback: [self call: (WACardapio cardapio: cardapio)];
		with: 'Visualizar Cardapio >>'.
	html break.
	html anchor id: 'novoPedido';
		callback: [self call: (WANovoPedido cardapio: cardapio)];
		with: 'Novo Pedido >>'.
	html break.
	html break.
	html break.
	html text: 'OBS: sim, é tosco, mas a cada entrada de texto você precisa apertar enter dentro da caixa para que a variável seja lida'.! !

!WAInicioGarcom methodsFor: 'rendering' stamp: 'go 6/11/2007 18:08'!
updateRoot: html
	super updateRoot: html.
	html title: 'Bem vindo'.! !


!WAInicioGarcom methodsFor: 'accessing' stamp: 'go 6/11/2007 21:25'!
cardapio: umCardapio
	cardapio := umCardapio.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

WAInicioGarcom class
	instanceVariableNames: ''!

!WAInicioGarcom class methodsFor: 'initialization' stamp: 'go 6/11/2007 18:18'!
initialize
	self registerAsApplication: 'ep2/fastfoodGarcom'! !


!WAInicioGarcom class methodsFor: 'testing' stamp: 'go 6/11/2007 18:18'!
canBeRoot
	^true! !


WAComponent subclass: #WANovoPedido
	instanceVariableNames: 'cardapio pedido'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood-IfaceGarcom'!
!WANovoPedido commentStamp: 'JFAE 6/12/2007 02:14' prior: 0!
Eu sou a classe que representa a pagina de um novo pedido.!


!WANovoPedido methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 02:17'!
cardapio: umCardapio
	cardapio := umCardapio.! !

!WANovoPedido methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 02:17'!
pedido: umPedido
	pedido := umPedido.! !


!WANovoPedido methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 22:18'!
renderContentOn: html
	html heading: 'Novo Pedido'.
	html break.
	html anchor id: 'cardapio';
		callback: [self call: (WACardapioPedido cardapio: cardapio pedido: pedido)];
		with: 'Visualizar Cardapio >>'.
	html break.
	html anchor id: 'novoPrato';
		callback: [self call: (WAPratoNovo cardapio: cardapio pedido: pedido)];
		with: 'Criar Prato Novo >>'.
	html break.
	html anchor id: 'verificaPedido';
		callback: [self call: (WAPedidoAtual pedido: pedido)];
		with: 'Verificar Pedido >>'.
	html break.
	html anchor id: 'cancelaPedido';
		callback: [self answer];
		with: 'Cancelar Pedido >>'.! !

!WANovoPedido methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 02:23'!
updateRoot: html
	super updateRoot: html.
	html title: 'Novo Pedido'.! !


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

WANovoPedido class
	instanceVariableNames: ''!

!WANovoPedido class methodsFor: 'initialization' stamp: 'JFAE 6/12/2007 02:20'!
cardapio: umCardapio
	| pagina |
	pagina := WANovoPedido new.
	pagina cardapio: umCardapio.
	pagina pedido: Pedido novo.
	^pagina.! !


WAComponent subclass: #WAPedidoAtual
	instanceVariableNames: 'pedido'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood-IfaceGarcom'!

!WAPedidoAtual methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 20:31'!
renderContentOn: html
	html table: [
		html tableRow: [
			html tableData: 'Prato'.
			html tableData: 'Preco'.
			html tableData: 'Quantidade'.
			html tableData: 'Total'.
		].
		pedido pratosUnicos do:
			[:x |
				html tableRow: [
					html tableData: x nome.
					html tableData: 'R$ ', x preco asString, ',00'.
					html tableData: (pedido quantidadePrato: x) asString.
					html tableData: 'R$ ', ((pedido quantidadePrato: x) * (x preco)) asString, ',00'.
				].
			].
		html tableRow: [
			html tableData: ''.
			html tableData: ''.
			html tableData: ''.
			html tableData: 'R$ ', pedido calculaPreco asString, ',00'.
		].
	].
	html anchor callback: [self answer];
		with: '<< Voltar'.
	html break.
	html anchor id: 'fecharPedido';
		callback: [self call: (WAFecharPedido pedido: pedido)];
		with: 'Fechar Pedido >>'.! !

!WAPedidoAtual methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 04:29'!
updateRoot: html
	super updateRoot: html.
	html title: 'Pedido Atual'.! !


!WAPedidoAtual methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 04:24'!
pedido: umPedido
	pedido := umPedido.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

WAPedidoAtual class
	instanceVariableNames: ''!

!WAPedidoAtual class methodsFor: 'initialization' stamp: 'JFAE 6/12/2007 04:25'!
pedido: umPedido
	| pagina |
	pagina := WAPedidoAtual new.
	pagina pedido: umPedido.
	^pagina.! !


WAComponent subclass: #WAPratoNovo
	instanceVariableNames: 'cardapio pedido preco listaIngredientes calPrato calLimite tipoLimitacao'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood-IfaceGarcom'!

!WAPratoNovo methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 19:39'!
adicionaIngrediente: ingrediente
	listaIngredientes addLast: ingrediente.
	preco := preco + ingrediente preco.
	calPrato := calPrato + ingrediente calorias.! !

!WAPratoNovo methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 18:22'!
adicionaPrato
	| novoPrato nome |
	pedido adicionaPersonalizados.
	nome := 'Prato Personalizado ', pedido personalizados asString.
	novoPrato := Prato novo: nome comPreco: preco feitoDe: listaIngredientes.
	pedido adicionaPrato: novoPrato.
	self inicializa.! !

!WAPratoNovo methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 17:30'!
cardapio: umCardapio
	cardapio := umCardapio.! !

!WAPratoNovo methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 19:07'!
eLimitado: bool
	eLimitado := bool.! !

!WAPratoNovo methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 19:39'!
inicializa
	listaIngredientes := OrderedCollection new.
	preco := 2.
	calPrato := 0.
	calLimite := 0.
	tipoLimitacao := 'Nao limitar calorias'.! !

!WAPratoNovo methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 17:46'!
listaIngredientes: lista
	listaIngredientes := lista.! !

!WAPratoNovo methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 17:29'!
pedido: umPedido
	pedido := umPedido.! !

!WAPratoNovo methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 18:00'!
preco: umPreco
	preco := umPreco.! !


!WAPratoNovo methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 19:51'!
renderContentOn: html
	| ingredientes tempLista |
	html form: [
		html break.
		tempLista := OrderedCollection new.
		tempLista addLast: 'Nao limitar calorias'.
		tempLista addLast: 'Limitar Inferiormente'.
		tempLista addLast: 'Limitar Superiormente'.
		html select list: tempLista;
			beSubmitOnChange;
			selected: tipoLimitacao;
			callback: [:val | tipoLimitacao := val.].
		html textInput callback: [
				:value | calLimite := value.
			];
			disabled: (tipoLimitacao = 'Nao limitar calorias');
			value: calLimite.
		html break.
		html text: '* pressione enter após digitar as calorias'.
	].
	html table: [
		html tableRow: [
			html tableData: 'Ingrediente'.
			html tableData: 'Preço'.
			html tableData: 'Calorias'.
			html tableData: ''.
		].
		cardapio ingredientesDoCardapio do:
			[:x | 
				html tableRow: [
					html tableData: x nome.
					html tableData: 'R$ ', x preco asString, ',00'.
					html tableData: x calorias asString, 'cal'.
					html tableData with: [
						html anchor callback: [self adicionaIngrediente: x];
							with: 'Adicionar'.
						].
				].
			].
	].
	listaIngredientes size = 0
	ifTrue: [
		ingredientes := ''.
	]
	ifFalse: [
		ingredientes := ''.
		1 to: (listaIngredientes size) - 1 do: [
			:x |
			ingredientes := ingredientes, (listaIngredientes at: x) nome, ','.
		].
		ingredientes := ingredientes, (listaIngredientes at: (listaIngredientes size)) nome.
	].
	html text: ingredientes.
	html break.
	html text: 'R$ ', preco asString, ',00'.
	html break.
	html text: calPrato asString, 'cal'.
	html break.
	html anchor callback: [self answer];
		with: '<< Voltar'.
	
	(tipoLimitacao = 'Limitar Inferiormente')
	ifTrue: [
		(calPrato > calLimite)
		ifTrue: [
			html break.
			html anchor callback: [self adicionaPrato];
				with: 'Adicionar Prato >>'.
		].
	].
	(tipoLimitacao = 'Limitar Superiormente')
	ifTrue: [
		(calPrato < calLimite)
		ifTrue: [
			html break.
			html anchor callback: [self adicionaPrato];
				with: 'Adicionar Prato >>'.
		].
	].
	(tipoLimitacao = 'Nao limitar calorias')
	ifTrue: [
		html break.
		html anchor callback: [self adicionaPrato];
			with: 'Adicionar Prato >>'.
	].! !

!WAPratoNovo methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 17:30'!
updateRoot: html
	super updateRoot: html.
	html title: 'Prato Novo'.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

WAPratoNovo class
	instanceVariableNames: ''!

!WAPratoNovo class methodsFor: 'initialization' stamp: 'JFAE 6/12/2007 18:18'!
cardapio: umCardapio pedido: umPedido
	| pagina |
	pagina := WAPratoNovo new.
	pagina pedido: umPedido.
	pagina cardapio: umCardapio.
	pagina inicializa.
	^pagina.! !

WAInicioGarcom initialize!