﻿WAComponent subclass: #WAAdicionaIngrediente
	instanceVariableNames: 'intNome ingValor ingCalorias ingNome'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood-IfaceGerente'!

!WAAdicionaIngrediente methodsFor: 'rendering' stamp: 'GO 6/12/2007 19:17'!
renderContentOn: html
	| ingrediente |
	html form: [
			html heading: 'Adicionar Ingrediente'.
			html horizontalRule.
			html form with:
				[   html text: 'Nome: '.
				    html textInput value: ingNome; callback: [:val | ingNome := val].
			         html text: 'Valor: '.
				    html textInput value: ingValor; callback: [:val | ingValor := val].
				    html text: 'Calorias: '.
				    html textInput value: ingCalorias; callback: [:val | ingCalorias := val].
				    html break.
			 	    html submitButton
				       callback: [ (ingNome = '')
								ifFalse: [ingrediente := Ingrediente novo: ingNome 
                                                                               comPreco: (ingValor asNumber) 
                                                                               comCalorias: (ingCalorias asNumber). 
                                                 self inform: 'Ingrediente adicionado com sucesso.'.
                                                 ((Cardapio unico) ingredientesDoCardapio) addLast: ingrediente.
                                       ]
								ifTrue: [self inform: 'Especifique o nome do ingrediente.']];
			      text: 'Adicionar'.
				].
			].! !


WAComponent subclass: #WAEditarCardapio
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood-IfaceGerente'!


WAComponent subclass: #WAInicioGerente
	instanceVariableNames: 'cardapio robo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood-IfaceGerente'!

!WAInicioGerente methodsFor: 'initialization' stamp: 'JFAE 6/12/2007 22:44'!
initialize
	super initialize.
	self registerForBacktracking.
	cardapio := Cardapio unico.
	robo := Robo novoComEstilo: 'fast-food'.! !


!WAInicioGerente methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 22:33'!
cardapio: umCardapio
	cardapio := umCardapio.! !


!WAInicioGerente methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 22:45'!
renderContentOn: html
	html heading: 'Interface do garçom'.
	html break.
	html anchor id: 'cardapio';
		callback: [self call: (WACardapio cardapio: cardapio)];
		with: 'Visualizar Cardapio >>'.
	html break.
	html anchor id: 'novoPedido';
		callback: [self call: (WANovoPedido cardapio: cardapio)];
		with: 'Novo Pedido >>'.
	html break.
	html anchor id: 'editaCardapio';
		callback: [self call: (WAEditarCardapio cardapio: cardapio)];
		with: 'Editar Cardapio >>'.
	html break.
	html anchor id: 'mensagemRobo';
		callback: [self call: (WAMensagemDoRobo robo: robo)];
		with: 'Mensagens do Robo >>'.
	html break.
	html break.
	html break.
	html text: 'OBS: sim, é tosco, mas a cada entrada de texto você precisa apertar enter dentro da caixa para que a variável seja lida'.! !

!WAInicioGerente methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 22:33'!
updateRoot: html
	super updateRoot: html.
	html title: 'Bem vindo'.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

WAInicioGerente class
	instanceVariableNames: ''!

!WAInicioGerente class methodsFor: 'testing' stamp: 'JFAE 6/12/2007 22:35'!
canBeRoot
	^true! !


!WAInicioGerente class methodsFor: 'initialization' stamp: 'JFAE 6/12/2007 23:08'!
initialize
	self registerAsApplication: 'ep2/fastfoodGerente'! !


WAComponent subclass: #WAListaDeEdicaoDeIngredientes
	instanceVariableNames: 'ingNome ingValor ingCalorias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood-IfaceGerente'!

!WAListaDeEdicaoDeIngredientes methodsFor: 'rendering' stamp: 'GO 6/12/2007 19:36'!
renderContentOn: html
	| lista listaNome temp campoPreco campoNome campoCalorias |
	html form: [
			html heading: 'Ingredientes'.
html paragraph: 'Clique no ingrediente que voce gostaria de remover.'.
				  		lista := (Cardapio unico) ingredientesDoCardapio.
						html text: 'Ingredientes: '.
						listaNome := html select.
						listaNome beSubmitOnChange.
						temp := (Cardapio unico) ingredientesDoCardapioNomes.
						temp addFirst: 'selecione'.
						listaNome list: temp.
						listaNome callback: [:val | lista do: [:each | ((each nome) = val) 
                                                                         ifTrue: [(Cardapio unico) removeIngrediente: each]]].
						html horizontalRule.
					     html paragraph: 'Clique no ingrediente para modifica-lo:'.
						html text: 'Ingredientes: '.
						listaNome := html select.
						listaNome beSubmitOnChange.
						listaNome list: temp.
						listaNome callback: [:val | lista do: [:each | ((each nome) = val) 
                                                                      ifTrue: [ "Bloco que edita um ingrediente a seguir..."
                        html heading: 'Ingredientes' level: 3.
					html paragraph: 'Altere aqui os dados do ingrediente ', each nome, ':'.
					html text: 'Nome: '.
					ingNome := each nome.
					ingValor := each preco asString.
					ingCalorias := each calorias asString.
					campoNome := html textInput.
					campoNome value: ingNome; callback: [:valor | ingNome := valor].
					html text: 'Preco: '.
					campoPreco := html textInput.
					campoPreco value: ingValor; callback: [:valor | ingValor := valor].
					html text: 'Calorias: '.
					campoCalorias := html textInput.
					campoCalorias value: ingCalorias; callback: [:valor | ingCalorias := valor].
					html submitButton text: 'Finalizar Edicao'; callback: [each nome: ingNome. each preco: (ingValor asNumber). each calorias: (ingCalorias asNumber). self inform: 'Ingrediente modificado com sucesso.'.]].
				 ].
	]. 
]! !


WAComponent subclass: #WAListaDeIngredientes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood-IfaceGerente'!

!WAListaDeIngredientes methodsFor: 'rendering' stamp: 'GO 6/12/2007 19:04'!
renderContentOn: html
	| lista temp |
	html form: [
			html heading: 'Ingredientes do Cardapio'.
			html paragraph: 'A seguir a lista de ingredientes disponiveis:'.
			lista := (Cardapio unico) ingredientesDoCardapio.
			lista do: [:each | temp := (each nome), 
                                  '     preco: ', ((each preco) asString), 
                                  '     calorias: ', ((each calorias) asString), 
                                  '     '. html listItem: temp].
	].! !


WAComponent subclass: #WAMensagemDoRobo
	instanceVariableNames: 'robo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood-IfaceGerente'!

!WAMensagemDoRobo methodsFor: 'accessing' stamp: 'JFAE 6/12/2007 22:48'!
robo: umRobo
	robo := umRobo.! !


!WAMensagemDoRobo methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 22:53'!
renderContentOn: html
	html heading: 'Mensagens do Robo'.
	robo mensagens do: [:each | html paragraph: each.].! !

!WAMensagemDoRobo methodsFor: 'rendering' stamp: 'JFAE 6/12/2007 22:47'!
updateRoot: html
	super updateRoot: html.
	html title: 'Mensagens Robo'.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

WAMensagemDoRobo class
	instanceVariableNames: ''!

!WAMensagemDoRobo class methodsFor: 'initialization' stamp: 'JFAE 6/12/2007 22:47'!
robo: umRobo
	| pagina |
	pagina := WAMensagemDoRobo.
	pagina robo: umRobo.
	^pagina.! !

WAInicioGerente initialize!