﻿Object subclass: #Caixa
	instanceVariableNames: ''
	classVariableNames: 'CaixaUnico PedidoAtual'
	poolDictionaries: ''
	category: 'RestauranteFastFood'!
!Caixa commentStamp: 'GO 4/22/2007 17:14' prior: 0!
Eu sou o caixa, como incutido no modelo 3 da especificacao. (Sou um Singleton)!


!Caixa methodsFor: 'consulta' stamp: 'GO 4/22/2007 17:34'!
imprimePratosDoCardapio
	"imprime a lista de todos os pratos do cardapio"

	| menu |
	menu := Cardapio unico.
	menu imprimePratos.
	! !

!Caixa methodsFor: 'consulta' stamp: 'GO 4/22/2007 17:32'!
pratosDoCardapio
	"retorna a lista de todos os pratos do cardapio"

	| menu |
	menu := Cardapio unico.
	^(menu pratosDoCardapio).
	! !

!Caixa methodsFor: 'consulta' stamp: 'GO 4/22/2007 17:24'!
totalDoPedido
	"retorna o preco total do pedido atual do caixa."

	^(PedidoAtual calculaPreco)	! !


!Caixa methodsFor: 'acoes' stamp: 'GO 4/22/2007 17:52'!
fechaPedido: umValor
	"checa o pagamento, da o troco e prepara o pedido."

	| troco |
	troco := umValor - (self totalDoPedido).
	troco >= 0
		ifFalse: [ Transcript show: 'Dinheiro insuficiente!!'.
					Transcript cr.
					^umValor.]
		ifTrue: [ Cozinheiro prepara: PedidoAtual. ^troco.].! !

!Caixa methodsFor: 'acoes' stamp: 'GO 4/22/2007 17:22'!
iniciaPedido
	"cria um novo pedido, ainda vazio. (unico para o caixa)"

	PedidoAtual := Pedido novo.
	! !

!Caixa methodsFor: 'acoes' stamp: 'GO 4/22/2007 17:21'!
pede: umPrato
	"adiciona um novo prato ao pedido"

	PedidoAtual adicionaPrato: umPrato.
	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Caixa class
	instanceVariableNames: ''!

!Caixa class methodsFor: 'inicializador' stamp: 'GO 4/22/2007 17:55'!
unico
	"devolve a instancia de caixa (singleton)"

	CaixaUnico = nil
		ifTrue: [CaixaUnico := Caixa new.]
		ifFalse: [].
	^CaixaUnico.! !


Object subclass: #Cardapio
	instanceVariableNames: ''
	classVariableNames: 'CardapioUnico Ingredientes Pratos'
	poolDictionaries: ''
	category: 'RestauranteFastFood'!

!Cardapio methodsFor: 'inicializador' stamp: 'JFAE 6/12/2007 14:46'!
inicializa
	"registra os ingredientes usados, cria a lista de pratos do cardapio e inicializa com os pratos padrao"

	| listaIngredientes pratoAtual ingredienteAtual |
	
	Pratos := OrderedCollection new.
	Ingredientes := OrderedCollection new.
	
	ingredienteAtual := Ingrediente novo: 'pao' comPreco: 2 comCalorias: 100.
	Ingredientes addLast: ingredienteAtual.
	ingredienteAtual := Ingrediente novo: 'carne' comPreco: 4 comCalorias: 200.
	Ingredientes addLast: ingredienteAtual.
	ingredienteAtual := Ingrediente novo: 'queijo' comPreco: 4 comCalorias: 200.
	Ingredientes addLast: ingredienteAtual.
	
	listaIngredientes := OrderedCollection new.
	listaIngredientes addLast: 'pao'.
	listaIngredientes addLast: 'carne'.
	listaIngredientes addLast: 'queijo'.
	pratoAtual := Prato novo: 'XBurguer' comPreco: 10 feitoDe: listaIngredientes.
	Pratos addLast: pratoAtual.
	
	ingredienteAtual :=  Ingrediente novo: 'alface' comPreco: 3 comCalorias: 20.
	Ingredientes addLast: ingredienteAtual.
	ingredienteAtual :=  Ingrediente novo: 'tomate' comPreco: 3 comCalorias: 40.
	Ingredientes addLast: ingredienteAtual.
	ingredienteAtual :=  Ingrediente novo: 'azeite' comPreco: 3 comCalorias: 100.
	Ingredientes addLast: ingredienteAtual.
	
	listaIngredientes := OrderedCollection new.
	listaIngredientes addLast: 'alface'.
	listaIngredientes addLast: 'tomate'.
	listaIngredientes addLast: 'azeite'.
	pratoAtual := Prato novo: 'Salada' comPreco: 9 feitoDe: listaIngredientes.
	Pratos addLast: pratoAtual.
	
	ingredienteAtual :=  Ingrediente novo: 'palmito' comPreco: 14 comCalorias: 50.
	Ingredientes addLast: ingredienteAtual.
	
	listaIngredientes := OrderedCollection new.
	listaIngredientes addLast: 'alface'.
	listaIngredientes addLast: 'palmito'.
	listaIngredientes addLast: 'azeite'.
	pratoAtual := Prato novo: 'Salada 2' comPreco: 20 feitoDe: listaIngredientes.
	Pratos addLast: pratoAtual.
	
	ingredienteAtual :=  Ingrediente novo: 'presunto' comPreco: 3 comCalorias: 100.
	Ingredientes addLast: ingredienteAtual.
	ingredienteAtual := Ingrediente novo: 'ovo' comPreco: 3 comCalorias: 100.
	Ingredientes addLast: ingredienteAtual.
	ingredienteAtual :=  Ingrediente novo: 'maionese' comPreco: 2 comCalorias: 100.
	Ingredientes addLast: ingredienteAtual.
	ingredienteAtual := Ingrediente novo: 'bacon' comPreco: 4 comCalorias: 200.
	Ingredientes addLast: ingredienteAtual.
	
	listaIngredientes := OrderedCollection new.
	listaIngredientes addLast: 'pao'.
	listaIngredientes addLast: 'carne'.
	listaIngredientes addLast: 'queijo'.
	listaIngredientes addLast: 'presunto'.
	listaIngredientes addLast: 'ovo'.
	listaIngredientes addLast: 'tomate'.
	listaIngredientes addLast: 'alface'.
	listaIngredientes addLast: 'maionese'.
	listaIngredientes addLast: 'bacon'.
	pratoAtual := Prato novo: 'Beirute' comPreco: 28 feitoDe: listaIngredientes.
	Pratos addLast: pratoAtual.
	
	ingredienteAtual :=  Ingrediente novo: 'gelo' comPreco: 1 comCalorias: 0.
	Ingredientes addLast: ingredienteAtual.
	ingredienteAtual :=  Ingrediente novo: 'laranja' comPreco: 2 comCalorias: 50.
	Ingredientes addLast: ingredienteAtual.
	
	listaIngredientes := OrderedCollection new.
	listaIngredientes addLast: 'gelo'.
	listaIngredientes addLast: 'laranja'.
	pratoAtual := Prato novo: 'Suco de Laranja' comPreco: 3 feitoDe: listaIngredientes.
	Pratos addLast: pratoAtual.

	ingredienteAtual :=  Ingrediente novo: 'massa' comPreco: 1 comCalorias: 100.
	Ingredientes addLast: ingredienteAtual.
	
	listaIngredientes := OrderedCollection new.
	listaIngredientes addLast: 'massa'.
	listaIngredientes addLast: 'ovo'.
	pratoAtual := Prato novo: 'Coxinha de Ovo' comPreco: 4 feitoDe: listaIngredientes.
	Pratos addLast: pratoAtual.
	
! !


!Cardapio methodsFor: 'consulta' stamp: 'JFAE 6/12/2007 15:28'!
imprimePratos
	"imprime a lista dos pratos contidos na cardapio"

	Pratos do: [:each | Transcript show: (each nome). Transcript cr.].! !

!Cardapio methodsFor: 'consulta' stamp: 'GHB 6/10/2007 22:46'!
ingredientesDoCardapio
	"retorna a lista dos ingredientes disponiveis"

	^Ingredientes.! !

!Cardapio methodsFor: 'consulta' stamp: 'GHB 6/11/2007 09:48'!
ingredientesDoCardapioNomes
	"retorna a lista dos ingredientes disponiveis"
	| lista |
	lista  := OrderedCollection new.
	Ingredientes do: [:each | lista addLast: each nome.].
	^lista.! !

!Cardapio methodsFor: 'consulta' stamp: 'GHB 6/10/2007 22:46'!
pratosDoCardapio
	"retorna a lista dos pratos contidos na cardapio"

	^Pratos.! !


!Cardapio methodsFor: 'acoes' stamp: 'GHB 6/10/2007 22:46'!
adicionaIngrediente: umIngrediente
	"adiciona um ingrediente a lista de ingredientes do cardapio"

	(Ingredientes includes: umIngrediente)
		ifFalse: [Ingredientes addLast: umIngrediente].! !

!Cardapio methodsFor: 'acoes' stamp: 'JFAE 6/12/2007 16:44'!
adicionaPrato: umPrato
	"adiciona um prato a lista de pratos do cardapio"
	| jaTem |
     jaTem := 0.
	Pratos do: [:each | ((each id) = (umPrato id))
                           ifTrue: [jaTem := 1].
				].
	(jaTem = 0)
     ifTrue: [ Pratos addLast: umPrato.].! !

!Cardapio methodsFor: 'acoes' stamp: 'GHB 6/10/2007 22:46'!
removeIngrediente: umIngrediente
	"remove ingrediente"

	Ingredientes remove: umIngrediente ifAbsent: [Transcript show: 'O ingrediente nao consta no menu'. 												Transcript cr].! !

!Cardapio methodsFor: 'acoes' stamp: 'GHB 6/10/2007 22:46'!
removePrato: umPrato
	"adiciona um prato a lista de pratos do cardapio"

	Pratos remove: umPrato ifAbsent: [Transcript show: 'O prato nao consta no menu'. 												Transcript cr].! !


!Cardapio methodsFor: 'testing' stamp: 'JFAE 6/12/2007 20:40'!
resetaCardapio
	"reinicia o singleton do cardapio"
	
	CardapioUnico := nil.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Cardapio class
	instanceVariableNames: ''!

!Cardapio class methodsFor: 'inicializador' stamp: 'JFAE 6/12/2007 15:27'!
unico
	"devolve a instancia de cardapio (singleton)"

	CardapioUnico = nil
		ifTrue: [CardapioUnico := Cardapio new. 
				CardapioUnico inicializa.
		]
		ifFalse: [].
	^CardapioUnico.! !


Object subclass: #Cozinheiro
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood'!
!Cozinheiro commentStamp: 'GO 4/22/2007 16:54' prior: 0!
Eu me comunico com o robo e mando ele fazer um pedido qualquer.!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Cozinheiro class
	instanceVariableNames: ''!

!Cozinheiro class methodsFor: 'acoes' stamp: 'GO 6/10/2007 15:45'!
prepara: umPedido
	"Faz a comunicacao para o preparo de um pedido."

	| robo |
	robo := Robo novoComEstilo: 'FastFood'.
	umPedido pegaPratos do: [:prato | prato ingredientes do: 
										[:ingrediente | robo prepara: (ingrediente).].
										robo juntaPrato.].
	! !


Object subclass: #Ingrediente
	instanceVariableNames: 'nome preco calorias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood'!

!Ingrediente methodsFor: 'consulta' stamp: 'GHB 6/10/2007 19:31'!
calorias
	"devolve o preco do ingrediente"
	^calorias.! !

!Ingrediente methodsFor: 'consulta' stamp: 'GHB 6/10/2007 19:29'!
nome
	"devolve o nome do ingrediente"
	^nome
! !

!Ingrediente methodsFor: 'consulta' stamp: 'GHB 6/10/2007 19:31'!
preco
	"devolve o preco do ingrediente"
	^preco.! !


!Ingrediente methodsFor: 'inicializadores' stamp: 'GHB 6/11/2007 11:56'!
calorias: quantidade
	"inicializa a quantidade de calorias do ingrediente"

	calorias := quantidade.! !

!Ingrediente methodsFor: 'inicializadores' stamp: 'GHB 6/10/2007 19:32'!
nome: umNome
	"inicializa o nome do ingrediente"

	nome := umNome.! !

!Ingrediente methodsFor: 'inicializadores' stamp: 'GHB 6/10/2007 19:33'!
preco: umValor
	"inicializa o valor do ingrediente"

	preco := umValor.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Ingrediente class
	instanceVariableNames: ''!

!Ingrediente class methodsFor: 'inicializador' stamp: 'GHB 6/10/2007 19:38'!
novo: umNome comPreco: umValor comCalorias: quantidade
	"inicializa um ingrediente com nome, preco, e quantidade de calorias passadas"

	| ingrediente |
	ingrediente := Ingrediente new.
	ingrediente nome: umNome.
	ingrediente preco: umValor.
	ingrediente calorias: quantidade.
	^ingrediente.! !


WAComponent subclass: #InterfaceGarcom
	instanceVariableNames: 'cardapio deveImprimir pedido valorMax valorMin novoPrato temp modoCalorias ultimaOpcao'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood'!

!InterfaceGarcom methodsFor: 'rendering' stamp: 'GHB 6/11/2007 17:45'!
renderContentOn: html
	| lista listaIngredientes total troco tempLista tempValor tempCalorias |
	html form: [
		html heading: 'Interface do Garcom'.
		html heading: 'Bem Vindo' level: 2.
		html horizontalRule.
		"Botao para imprimir os pratos do cardapio:"
		html heading: 'Visualizar a Lista de Pratos' level: 2.
		html submitButton
			callback: [(deveImprimir = 1)
					ifTrue: [deveImprimir := 0]
					ifFalse: [deveImprimir := 1].];
			text: 'do Cardapio'.
		html space: 15.
	     "Botoes para o filtro do cardapio por preco"
		html submitButton
			callback: [deveImprimir := 6.
					valorMax := (self request: 'Valor Maximo' default: 0) asNumber.];
			text: 'do Cardapio (filtro de preco MAX)'.
		html space: 15.
				html submitButton
			callback: [deveImprimir := 7.
					valorMin := (self request: 'Valor Minimo' default: 0) asNumber.];
			text: 'do Cardapio (filtro de preco MIN)'.
		html space: 15.
		"Botao para imprimir os pratos do pedido atual:"
		html submitButton
			callback:  [(deveImprimir = 2)
					ifTrue: [deveImprimir := 0]
					ifFalse: [deveImprimir := 2].];
			text: 'do Pedido Atual'.	
		html horizontalRule.
		html heading: 'Edicao do Pedido Atual' level: 2.
		"Botao para iniciar um novo pedido:"
		html submitButton
			callback: [pedido := Pedido novo.];
			text: 'Iniciar novo Pedido'.
		html space: 25.
		"Botao para abrir o menu de adicionar um prato ao pedido:"		
		html submitButton
			callback: [(pedido = nil)
				ifTrue: [self inform: 'O pedido nao foi inicializado ainda, inicialize-o antes.']
				ifFalse: [deveImprimir := 3]];
			text: 'Adicionar pratos ao pedido'.
		html space: 25.
		"Botao para fechar o pedido:"		
		html submitButton
			callback: [(pedido = nil)
				ifTrue: [self inform: 'O pedido nao foi inicializado ainda, inicialize-o antes.']
				ifFalse: [ total := (self request: 'dinheiro' default: 0) asNumber.
					       (total >= pedido calculaPreco)
						  ifTrue:[Cozinheiro prepara: pedido.
							      troco := (total - (pedido calculaPreco)).
							      pedido := nil.
								 self inform: 'Pedido Fechado, obrigado. Troco: ',
								 (troco asString).]
						  ifFalse:[self inform: 'Dinheiro insuficiente!!']
					     ]
				];
			text: 'Fecha pedido'.
		html horizontalRule.
		"Bloco que imprime os pratos do cardapio se necessario:"
		(deveImprimir = 1)
		ifTrue:  [	html heading: 'Pratos do Cardapio' level: 3.
				html paragraph: 'A seguir o cardapio de pratos:'.
				lista := cardapio pratosDoCardapio.
				lista do: [:each | html listItem: (each nome).].
				].
		"Bloco que imprime os pratos do pedido atual:"
		(deveImprimir = 2)
		ifTrue:  [	html heading: 'Pratos do Pedido' level: 3.
				html paragraph: 'A seguir os pratos do pedido atual:'.
				(pedido = nil)
					ifTrue: [html listItem: 'Pedido nao inicializado.']
					ifFalse: [html text: 'Preco total do pedido: '.
						html text: (pedido calculaPreco).
						lista := pedido pegaPratos.
						lista do: [:each | html listItem: (each nome).].
						].
				].
		"Bloco que imprime a lista para adicionar pratos:"
		(deveImprimir = 3)
		ifTrue:  [ html paragraph: 'Clique no prato que voce gostaria de adicionar.'.
			       lista := cardapio pratosDoCardapio.
			       lista do: [:each | html paragraph.
								   html submitButton
								   	   callback: [pedido adicionaPrato: each.];
									   text: (each nome).
						  ].
					html horizontalRule.
				   html heading: 'Monte seu prato.' level: 3.
					html text: 'Limitar Calorias:'.
					html textInput value: temp; callback: [:val | temp := val].
					html space: 15.
					tempLista := OrderedCollection new.
					tempLista addLast: 'Nao limitar calorias.'.
					tempLista addLast: 'Limitar Inferiormente.'.
					tempLista addLast: 'Limitar Superiormente.'.
					html select list: tempLista; beSubmitOnChange; selected: ultimaOpcao; callback: [:val | (val = 'Nao limitar calorias.') 
																					ifTrue: [modoCalorias := 0.].
																					(val = 'Limitar Inferiormente.')
																					ifTrue: [modoCalorias := 1.].
																				 	(val = 'Limitar Superiormente.')
																					ifTrue: [modoCalorias := 2.].
																					ultimaOpcao := val.].
				   html paragraph: 'Clique nos ingredientes que voce gostaria de adicionar ao novo prato'.
 					(novoPrato = nil)
						ifTrue: [ novoPrato := OrderedCollection new.].
					tempCalorias := 0.
					novoPrato do: [:each | tempCalorias := tempCalorias + (each calorias)].	
				   	listaIngredientes := cardapio ingredientesDoCardapio.
					listaIngredientes do: [:each | (modoCalorias = 2)
												ifTrue: [
												(tempCalorias + (each calorias) < (temp asNumber))
												ifTrue: [
													html paragraph.
													html submitButton
													callback: [novoPrato addLast: each];
													text: (each nome).
												] ifFalse: [
													html paragraph: (each nome).
												].
											] ifFalse: [
													html paragraph.
													html submitButton
													callback: [novoPrato addLast: each];
													text: (each nome).
											].
									  	].
						html horizontalRule.
					html paragraph: 'Ingredientes adicionados ao novo prato: '.
					((novoPrato size) >= 1)
						ifTrue: [ tempLista := OrderedCollection new.
									tempValor := 0.
									tempCalorias := 0.
								 	novoPrato do: [:each | html listItem: (each nome). tempLista addLast: (each nome). tempValor := tempValor + (each preco). tempCalorias := tempCalorias + (each calorias).].
									html paragraph: 'Valor: ', (tempValor asString), ' | Calorias: ', (tempCalorias asString).
									html paragraph.
									(modoCalorias = 1) 
										ifTrue: [
										(tempCalorias >= temp)
											ifTrue: [
											html submitButton text: 'Adicionar novo prato';
																callback: [pedido adicionaPrato: 
																			(Prato novo: 'prato personalizado' 
																							comPreco: (tempValor + 2)
																							feitoDe: tempLista)].
											html space: 15.
											].
										]
										ifFalse: [ 											
											html submitButton text: 'Adicionar novo prato';
																callback: [pedido adicionaPrato: 
																			(Prato novo: 'prato personalizado' 
																							comPreco: (tempValor + 2)
																							feitoDe: tempLista)].
											html space: 15. 
										].
									html submitButton text: 'Cancelar novo prato';
														callback: [novoPrato := nil].
								].

									
				 ].
		
		"Blocos que imprimem os pratos do cardapio com filtro:"
		(deveImprimir = 6)
		ifTrue:  [html heading: 'Pratos do Cardapio' level: 3.
				html paragraph: 'A seguir o cardapio de pratos:'.
				lista := cardapio pratosDoCardapio.
				lista do: [:each | (valorMax >= (each preco))
					     ifTrue: [html listItem: (each nome)].
				          ].
			     ].	
		(deveImprimir = 7)
		ifTrue:  [html heading: 'Pratos do Cardapio' level: 3.
				html paragraph: 'A seguir o cardapio de pratos:'.
				lista := cardapio pratosDoCardapio.
				lista do: [:each | (valorMin <= (each preco))
					     ifTrue: [html listItem: (each nome)].
				          ].
			     ].	
		]! !


!InterfaceGarcom methodsFor: 'initialization' stamp: 'GHB 6/11/2007 20:00'!
initialize
	super initialize.
	self registerForBacktracking.
	cardapio := Cardapio unico.
	deveImprimir := 0.
	valorMax := 0.
	valorMin := 0.
	temp := 0.
	modoCalorias := 0.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

InterfaceGarcom class
	instanceVariableNames: ''!

!InterfaceGarcom class methodsFor: 'testing' stamp: 'GO 6/8/2007 15:26'!
canBeRoot
	^true! !


!InterfaceGarcom class methodsFor: 'initialization' stamp: 'GO 6/8/2007 15:27'!
initialize
	self registerAsApplication: 'ep2/interfaceGarcom'! !


WAComponent subclass: #InterfaceGerente
	instanceVariableNames: 'cardapio deveImprimir pedido prato valorMax valorMin ingrediente ingNome ingValor ingCalorias pratoNome pratoValor listaIngredientesFinal'
	classVariableNames: 'MenRobo'
	poolDictionaries: ''
	category: 'RestauranteFastFood'!

!InterfaceGerente methodsFor: 'initialization' stamp: 'GHB 6/11/2007 18:34'!
initialize
	super initialize.
	self registerForBacktracking.
	cardapio := Cardapio unico.
	deveImprimir := 0.
	prato := Prato novo: '' comPreco: 0 feitoDe: OrderedCollection new.
	valorMax := 0.
	valorMin := 0.
	ingNome := ''.
	ingValor := 0.
	ingCalorias := 0.! !


!InterfaceGerente methodsFor: 'rendering' stamp: 'GHB 6/11/2007 18:37'!
funcsIngredientes: html

		"Bloco que imprime os ingredientes disponiveis:"
		| lista listaNome temp campoNome campoPreco campoCalorias |
		
	(deveImprimir = 8)
		ifTrue:  [	html heading: 'Ingredientes' level: 3.
				html paragraph: 'A seguir a lista de ingredientes disponiveis:'.
				lista := cardapio ingredientesDoCardapio.
				lista do: [:each | temp := (each nome), ' preco: ', ((each preco) asString), ' calorias: ', ((each calorias) asString), ' '. html listItem: temp].
				].
			
		"Bloco que adiciona ingredientes:"
		(deveImprimir = 9)
		ifTrue:  [	
				html heading: 'Ingredientes' level: 3.
				html paragraph: 'Adicione abaixo um ingrediente:'.
				html form with:
				[ html text: 'Nome: '.
				 html textInput value: ingNome; callback: [:val | ingNome := val].
				html text: 'Valor: '.
				 html textInput value: ingValor; callback: [:val | ingValor := val].
				 html text: 'Calorias: '.
				 html textInput value: ingCalorias; callback: [:val | ingCalorias := val].
				html break.
				html submitButton
				 callback: [ (ingNome = '')
								ifFalse: [ingrediente := Ingrediente novo: ingNome comPreco: (ingValor asNumber) comCalorias: (ingCalorias asNumber). deveImprimir := 10]
								ifTrue: [self inform: 'Especifique o nome do ingrediente.']];
			      text: 'Adicionar'.
				].
			].
		
		(deveImprimir = 10)
		ifTrue: [
			html heading: 'Ingrediente Adicionado com Sucesso!!' level: 3.	
			(cardapio ingredientesDoCardapio) addLast: ingrediente.
		].
				
		"Bloco que imprime a lista de edicao de Ingredientes:"
		(deveImprimir = 11)
		ifTrue:  [ html heading: 'Ingredientes' level: 3.
					html paragraph: 'Clique no ingrediente que voce gostaria de remover.'.
				  		lista := cardapio ingredientesDoCardapio.
						html text: 'Ingredientes: '.
						listaNome := html select.
						listaNome beSubmitOnChange.
						temp := cardapio ingredientesDoCardapioNomes.
						temp addFirst: 'selecione'.
						listaNome list: temp.
						listaNome callback: [:val | lista do: [:each | ((each nome) = val) ifTrue: [ cardapio removeIngrediente: each]]].
						html horizontalRule.
					html paragraph: 'Clique no ingrediente para modifica-lo:'.
						html text: 'Ingredientes: '.
						listaNome := html select.
						listaNome beSubmitOnChange.
						listaNome list: temp.
						listaNome callback: [:val | lista do: [:each | ((each nome) = val) ifTrue: [ ingrediente := each. deveImprimir := 12]]].
				 ].
			
		"Bloco para a edicao de ingredientes"
		(deveImprimir = 12)
		ifTrue: [html heading: 'Ingredientes' level: 3.
					html paragraph: 'Altere aqui os dados do ingrediente ', ingrediente nome, ':'.
					html text: 'Nome: '.
					ingNome := ingrediente nome.
					ingValor := ingrediente preco asString.
					ingCalorias := ingrediente calorias asString.
					campoNome := html textInput.
					campoNome value: ingNome; callback: [:val | ingNome := val].
					html text: 'Preco: '.
					campoPreco := html textInput.
					campoPreco value: ingValor; callback: [:val | ingValor := val].
					html text: 'Calorias: '.
					campoCalorias := html textInput.
					campoCalorias value: ingCalorias; callback: [:val | ingCalorias := val].
					html submitButton text: 'Finalizar Edicao'; callback: [ingrediente nome: ingNome. ingrediente preco: (ingValor asNumber). ingrediente calorias: (ingCalorias asNumber). deveImprimir := 13].
					].
		(deveImprimir = 13)
		ifTrue: [html heading: 'Ingredientes' level: 3.
					html paragraph: 'Ingrendiente modificado com sucesso!!'.
			].
! !

!InterfaceGerente methodsFor: 'rendering' stamp: 'GHB 6/11/2007 18:30'!
funcsPratos: html

		"Bloco que imprime os pratos do cardapio se necessario:"
		| lista listaIngredientes |
	(deveImprimir = 1)
		ifTrue:  [	html heading: 'Pratos do Cardapio' level: 3.
				html paragraph: 'A seguir o cardapio de pratos:'.
				lista := cardapio pratosDoCardapio.
				lista do: [:each | html listItem: (each nome).].
				].
		"Bloco que imprime os pratos do pedido atual:"
		(deveImprimir = 2)
		ifTrue:  [	html heading: 'Pratos do Pedido' level: 3.
				html paragraph: 'A seguir os pratos do pedido atual:'.
				(pedido = nil)
					ifTrue: [html listItem: 'Pedido nao inicializado.']
					ifFalse: [html text: 'Preco total do pedido: '.
						html text: (pedido calculaPreco).
						lista := pedido pegaPratos.
						lista do: [:each | html listItem: (each nome).].
						].
				].
		"Bloco que imprime a lista para adicionar pratos:"
		(deveImprimir = 3)
		ifTrue:  [ html paragraph: 'Clique no prato que voce gostaria de adicionar.'.
			       lista := cardapio pratosDoCardapio.
			       lista do: [:each | html paragraph.
								   html submitButton
								   	   callback: [pedido adicionaPrato: each.];
									   text: (each nome).
						  ].     
				 ].
		"Bloco que imprime a lista de mensagens do robo:"
		(deveImprimir = 4)
		ifTrue:  [ (MenRobo = nil)
				   ifFalse: [MenRobo do: [:each | html paragraph: each.]]
				 ].
		"Bloco que imprime a lista de edicao do cardapio:"
		(deveImprimir = 5)
		ifTrue:  [ html paragraph: 'Clique no prato que voce gostaria de remover.'.
				  lista := cardapio pratosDoCardapio.
			       lista do: [:each | html paragraph.
								   html submitButton
								   	   callback: [cardapio removePrato: each.];
									   text: (each nome).
						  ].
				   html horizontalRule.
				   html paragraph: 'Prato Atual:'.
				   html listItem: 'Nome: '.
				   html text: (pratoNome).
				   html listItem: 'Ingredientes: '.
				   listaIngredientes := (Cardapio unico) ingredientesDoCardapioNomes.
				   listaIngredientes addFirst: 'Adicione o ingrediente'.
				   listaIngredientesFinal do: [:each | html text: each. html space: 5.].
				   html listItem: 'Preco: '.
				   html text: (pratoValor).
        			   html paragraph: 'Use os campos abaixo para adicionar um novo prato.'.
				   html paragraph: 'Nome: '.
				   html textInput value: pratoNome; callback: [:val | pratoNome := val].
				   html paragraph: 'Preco: '.
				   html textInput value: pratoValor; callback: [:val | pratoValor := (val asNumber)].
				   html paragraph: 'Ingredientes: '.
				   html select list: listaIngredientes; beSubmitOnChange; callback: [:val | listaIngredientesFinal addLast: val].
				   html submitButton
				       callback: [(pratoNome = '')
					               ifTrue: [self inform: 'Nome do prato nao especificado!!'.]
					               ifFalse: [(pratoValor = 0)
						                     ifTrue: [self inform: 'Preco do prato nao especificado'.]
						                     ifFalse: [(listaIngredientesFinal hasContentsInExplorer)
							                           ifFalse:[ 
							                            self inform: 'Especifique Ingredientes.']
							                           ifTrue:[
													prato nome: pratoNome.
													prato preco: pratoValor.
												     prato ingredientes: listaIngredientesFinal.
							                             cardapio adicionaPrato: prato.
													listaIngredientesFinal := OrderedCollection new.
													pratoNome := ''.
 												     pratoValor := 0.
													]
							                         ]
						           ]
					  ];
				       text: 'Insira Prato no Cardapio'.
				 ].
			
			
	
			"Blocos que imprimem os pratos do cardapio com filtro:"
		(deveImprimir = 6)
		ifTrue:  [html heading: 'Pratos do Cardapio' level: 3.
				html paragraph: 'A seguir o cardapio de pratos:'.
				lista := cardapio pratosDoCardapio.
				lista do: [:each | (valorMax >= (each preco))
					     ifTrue: [html listItem: (each nome)].
				          ].
			     ].	
	
			(deveImprimir = 7)
		ifTrue:  [html heading: 'Pratos do Cardapio' level: 3.
				html paragraph: 'A seguir o cardapio de pratos:'.
				lista := cardapio pratosDoCardapio.
				lista do: [:each | (valorMin <= (each preco))
					     ifTrue: [html listItem: (each nome)].
				          ].
			     ].	! !

!InterfaceGerente methodsFor: 'rendering' stamp: 'GHB 6/11/2007 18:29'!
menu: html

	| total troco |
	html heading: 'Interface do Gerente'.
		html heading: 'Bem Vindo' level: 2.
		html horizontalRule.
		html heading: 'Ingredientes' level: 2.
		"Botao para imprimir os ingredientes disponiveis"
		html submitButton
			callback: [ deveImprimir := 8.];
			text: 'Listar'.
		html space: 15.
		"Botao para adicionar ingredientes"
		html submitButton
			callback: [deveImprimir := 9.];
			text: 'Adicionar Novo Ingrediente'.
		html space: 15.
		html submitButton
			callback: [deveImprimir := 11.];
			text: 'Editar Ingredientes'.
		html space: 15.
		html horizontalRule.
		"Botao para imprimir os pratos do cardapio:"
		html heading: 'Visualizar a Lista de Pratos' level: 2.
		html submitButton
			callback: [(deveImprimir = 1)
					ifTrue: [deveImprimir := 0]
					ifFalse: [deveImprimir := 1].];
			text: 'do Cardapio'.
		html space: 15.
		"Botoes para o filtro do cardapio por preco"
		html submitButton
			callback: [deveImprimir := 6.
					valorMax := (self request: 'Valor Maximo' default: 0) asNumber.];
			text: 'do Cardapio (filtro de preco MAX)'.
		html space: 15.
				html submitButton
			callback: [deveImprimir := 7.
					valorMin := (self request: 'Valor Minimo' default: 0) asNumber.];
			text: 'do Cardapio (filtro de preco MIN)'.
		html space: 15.
		"Botao para imprimir os pratos do pedido atual:"
		html submitButton
			callback:  [(deveImprimir = 2)
					ifTrue: [deveImprimir := 0]
					ifFalse: [deveImprimir := 2].];
			text: 'do Pedido Atual'.	
		html horizontalRule.
		html heading: 'Edicao do Pedido Atual' level: 2.
		"Botao para iniciar um novo pedido:"
		html submitButton
			callback: [pedido := Pedido novo.];
			text: 'Iniciar novo Pedido'.
		html space: 25.
		"Botao para abrir o menu de adicionar um prato ao pedido:"		
		html submitButton
			callback: [(pedido = nil)
				ifTrue: [self inform: 'O pedido nao foi inicializado ainda, inicialize-o antes.']
				ifFalse: [deveImprimir := 3]];
			text: 'Adicionar pratos ao pedido'.
		html space: 25.
		"Botao para fechar o pedido:"		
		html submitButton
			callback: [(pedido = nil)
				ifTrue: [self inform: 'O pedido nao foi inicializado ainda, inicialize-o antes.']
				ifFalse: [ total := (self request: 'dinheiro' default: 0) asNumber.
					       (total >= pedido calculaPreco)
						  ifTrue:[Cozinheiro prepara: pedido.
							      troco := (total - (pedido calculaPreco)).
							      pedido := nil.
								 self inform: 'Pedido Fechado, obrigado. Troco: ',
								 (troco asString).]
						  ifFalse:[self inform: 'Dinheiro insuficiente!!']
					     ]
				];
			text: 'Fecha pedido'.
		html horizontalRule.
		"Bloco exclusivo do gerente, pode visualizar as mensagens do robo e modificar o cardapio"
		html heading: 'Pagina do gerente' level: 2.
		"Botao para verificar a ultimas mensagens do robo"
		html submitButton
			callback: [deveImprimir := 4.];
			text: 'Lista Mensagens do Robo'.
		html space: 15.
		"Botao para editar o cardapio."
		html submitButton
			callback: [deveImprimir := 5.
				        listaIngredientesFinal := OrderedCollection new.
					   pratoNome := ''.
					   pratoValor := 0.];
			text: 'Editar o Cardapio'.
		html horizontalRule.
		
		! !

!InterfaceGerente methodsFor: 'rendering' stamp: 'GHB 6/11/2007 12:43'!
renderContentOn: html
	||
	html form: [
		self menu: html.
		self funcsPratos: html.
		self funcsIngredientes: html.
	].! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

InterfaceGerente class
	instanceVariableNames: ''!

!InterfaceGerente class methodsFor: 'testing' stamp: 'GO 6/10/2007 16:17'!
canBeRoot
	^true! !

!InterfaceGerente class methodsFor: 'testing' stamp: 'GO 6/10/2007 17:14'!
menRobo
	(MenRobo = nil)
	ifTrue: [MenRobo := OrderedCollection new.].
	^MenRobo! !


!InterfaceGerente class methodsFor: 'initilization' stamp: 'GO 6/10/2007 16:19'!
initialize
	self registerAsApplication: 'ep2/interfaceGerente'! !


Object subclass: #Pedido
	instanceVariableNames: 'pratos personalizados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood'!
!Pedido commentStamp: 'GO 4/20/2007 00:52' prior: 0!
Eu implemento um pedido, tenho uma lista de pratos e sei calcular o meu preco!!!


!Pedido methodsFor: 'inicializador' stamp: 'JFAE 6/12/2007 17:53'!
inicializa
	"inicializa um novo pedido."

	pratos := OrderedCollection new.
	personalizados := 0.! !


!Pedido methodsFor: 'acoes' stamp: 'JFAE 6/12/2007 17:55'!
adicionaPersonalizados
	"adiciona um prato personalizado no pedido"

	personalizados := personalizados + 1.! !

!Pedido methodsFor: 'acoes' stamp: 'GO 4/20/2007 00:57'!
adicionaPrato: umPrato
	"Adiciona um prato a lista de pratos"

	pratos addLast: umPrato.! !

!Pedido methodsFor: 'acoes' stamp: 'GO 4/20/2007 01:05'!
calculaPreco
	"calcula o preco de um pedido"

	| total |
	total := 0.
	pratos do: [:each | total := total + (each preco).].
	^total.! !

!Pedido methodsFor: 'acoes' stamp: 'GO 4/20/2007 01:02'!
imprimePratos
	"imprime todos os pratos do pedido"
	
	pratos do: [:each | Transcript show: (each nome).
						Transcript cr.]! !

!Pedido methodsFor: 'acoes' stamp: 'GO 4/20/2007 01:03'!
pegaPratos
	"devolve a lista dos pratos do pedido"
	
	^pratos.! !

!Pedido methodsFor: 'acoes' stamp: 'JFAE 6/12/2007 17:54'!
personalizados
	"retorna o número de pratos personalizados"

	^personalizados.! !

!Pedido methodsFor: 'acoes' stamp: 'JFAE 6/12/2007 15:45'!
pratosUnicos
	"retorna uma lista ordenada com apenas uma ocorrencia de cada tipo de prato"

	| resposta |
	resposta := OrderedCollection new.
	1 to: pratos size do: [
		:x |
		| flag |
		flag := false.
		1 to: x-1 do: [
			:y |
			(pratos at: x) nome = (pratos at: y) nome
			ifTrue: [
				flag := true.
			].
		].
		flag ifFalse: [ resposta add: (pratos at: x) ].
	].
	^resposta.! !

!Pedido methodsFor: 'acoes' stamp: 'JFAE 6/12/2007 15:49'!
quantidadePrato: umPrato
	"verifica o número de ocorrências de um determinado prato no pedido"

	| qtde |
	qtde := 0.
	self pegaPratos do: [
		:each |
		each nome = umPrato nome
		ifTrue: [ qtde := qtde + 1].
		].
	^qtde.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Pedido class
	instanceVariableNames: ''!

!Pedido class methodsFor: 'inicializador' stamp: 'GO 4/20/2007 00:55'!
novo
	"cria e devolve um novo pedido inicializado"

	| pedido |
	pedido := Pedido new.
	pedido inicializa.
	^pedido.! !


Object subclass: #Prato
	instanceVariableNames: 'nome preco ingredientes id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RestauranteFastFood'!
!Prato commentStamp: 'GO 4/20/2007 00:37' prior: 0!
Eu implemento um prato, tenho um nome, um valor e uma lista de ingredientes.!


!Prato methodsFor: 'consulta' stamp: 'JFAE 6/12/2007 03:32'!
id
	"devolve o id do prato"

	^id.! !

!Prato methodsFor: 'consulta' stamp: 'GO 4/20/2007 00:50'!
imprimeIngredientes
	"imprime a lista de ingredientes do prato"

	ingredientes do: [:each | Transcript show: each. 
							Transcript cr.]! !

!Prato methodsFor: 'consulta' stamp: 'GO 4/20/2007 00:47'!
ingredientes
	"devolve a lista de ingredientes do prato"

	^ingredientes.! !

!Prato methodsFor: 'consulta' stamp: 'JFAE 6/12/2007 01:39'!
listaIngredientes
	"imprime a lista de ingredientes do prato separados por virgulas"

	| lista tamanho |
	lista := ''.
	tamanho := ingredientes size.
	1 to: tamanho - 1 do: [:x |
		| element |
		element := ingredientes at: x.
		lista := lista, element, ','.
		].
	lista := lista, (ingredientes at: tamanho).
	^lista.! !

!Prato methodsFor: 'consulta' stamp: 'GO 4/20/2007 01:01'!
nome
	"devolve o nome do prato"

	^nome.! !

!Prato methodsFor: 'consulta' stamp: 'GO 4/20/2007 00:46'!
preco
	"devolve o preco do prato"

	^preco.! !


!Prato methodsFor: 'inicializador' stamp: 'JFAE 6/12/2007 14:31'!
id: umId
	"inicializa o id do prato"

	id := umId.! !

!Prato methodsFor: 'inicializador' stamp: 'GO 4/20/2007 00:41'!
ingredientes: umaLista
	"inicializa a lista de ingredientes do prato"

	ingredientes := OrderedCollection new.
	ingredientes addAll: umaLista.! !

!Prato methodsFor: 'inicializador' stamp: 'JFAE 6/12/2007 14:31'!
nome: umNome
	"inicializa o nome do prato e seu respectivo id"

	nome := umNome.! !

!Prato methodsFor: 'inicializador' stamp: 'GO 4/20/2007 00:40'!
preco: umValor
	"inicializa o valor do prato"

	preco := umValor.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Prato class
	instanceVariableNames: ''!

!Prato class methodsFor: 'inicializador' stamp: 'JFAE 6/12/2007 15:25'!
novo: umNome comPreco: umValor feitoDe: umaLista
	"inicializa um prato com o nome, preco e ingredientes passados"

	| prato aux novoId |
	prato := Prato new.
	prato nome: umNome.
	prato preco: umValor.
	prato ingredientes: umaLista.
	
	aux := umNome asLowercase substrings asOrderedCollection.
	novoId := ''.
	aux do: [:each | novoId := novoId, each].
	prato id: novoId.

	^prato.! !


Object subclass: #Robo
	instanceVariableNames: 'Estilo Mensagens'
	classVariableNames: 'RoboUnico'
	poolDictionaries: ''
	category: 'RestauranteFastFood'!
!Robo commentStamp: 'GO 4/20/2007 00:26' prior: 0!
Eu implemento o robo, como descrito no enunciado.!


!Robo methodsFor: 'acoes' stamp: 'JFAE 6/12/2007 22:52'!
juntaPrato
	"o robo junta os ingredientes preparados em um prato."

	Transcript show: 'Prato Terminado!!'.
	Transcript cr.
	Mensagens addLast: 'Prato Terminado.'.! !

!Robo methodsFor: 'acoes' stamp: 'JFAE 6/12/2007 22:52'!
prepara: umIngrediente
	"prepara o prato, como descrito no ep."
	| mens |
	mens := 'Preparei ', umIngrediente, '!!'.
	Transcript show: mens.
	Transcript cr.
	Mensagens addLast: mens.! !


!Robo methodsFor: 'consulta' stamp: 'GO 4/20/2007 00:36'!
estilo
	"devolve o estilo do robo"

	Transcript show: 'Estilo do robo: ',Estilo.
	Transcript cr.! !

!Robo methodsFor: 'consulta' stamp: 'JFAE 6/12/2007 22:53'!
mensagens
	"retorna a lista de mensagens do robo"

	^Mensagens.! !


!Robo methodsFor: 'inicializador' stamp: 'JFAE 6/12/2007 22:51'!
inicializa: umEstilo
	"inicializa o robo com o estilo pedido"

	Estilo := umEstilo.
	Mensagens := OrderedCollection new.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Robo class
	instanceVariableNames: ''!

!Robo class methodsFor: 'inicializador' stamp: 'GO 4/22/2007 17:03'!
novoComEstilo: umEstilo
	"inicializa um robo com o estilo pedido."
	
	RoboUnico = nil
		ifTrue: [RoboUnico := Robo new. RoboUnico inicializa: umEstilo.].
	^RoboUnico.! !

InterfaceGarcom initialize!
InterfaceGerente initialize!